/*
* AdminMod Manager
* (c) by Sir D. 29.01.2007
*
* With this plugin, you can edit your adminmod files.
* After editing/changing something, you need to make a mapchange to take effect.
*
* Needed:
* - file_access_read 1, file_access_write 1, amv_enable_beta "menu1", ACCESS_RCON
*
* Command:
* admin_manager
*
* ATTENTION:
* - PLEASE MAKE A COPY OF YOUR FILES, BEFORE YOU USE THIS PLUGIN!!!
*/

#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH]="AM_2.50.60_b0.8";


//FILES
#define FILES	8
new g_FileDir[MAX_TEXT_LENGTH]="addons/adminmod/config/";
new g_File[FILES][]={
	"",
	"adminmod.cfg",
	"plugin.ini",
	"maps.ini",
	"users.ini",
	"models.ini",
	"vault.ini",
	"wordlist.txt"
};

//MENU (single client version only)
#define MAX_MENU_LENGTH	1500
#define MAIN_MENU	1
#define LINE_MENU	2
#define SELECT_MENU	3
#define EXEC_MENU	4
#define ITEMS_PER_PAGE	5
#define CANCEL		10
#define NEXT		9
#define BACK		8
#define ADD			7
#define EDIT		1
#define COMMENT		2

new g_ClientLogin;
new g_ClientKeyStart;
new g_ClientKeyEnd;
new g_change;
new g_ClientMenu;
new g_ClientFile[MAX_TEXT_LENGTH];
new g_ClientSelect;
new g_ClientContent[MAX_TEXT_LENGTH];
new g_ClientMessageMode;
new g_ClientNewContent[MAX_TEXT_LENGTH];

public plugin_init(){
	new Menu[MAX_NAME_LENGTH];
	new iFileAccessRead;
	new iFileAccessWrite;
	new error;
	
	//Check settings
	getstrvar("amv_enable_beta",Menu,MAX_NAME_LENGTH);
	iFileAccessRead=getvar("file_access_read");
	iFileAccessWrite=getvar("file_access_write");
	
	if(strstrx(Menu,"menu1")==-1){
		selfmessage("[AdminMod Manager] amv_enable_beta is not set to ^"menu1^" in adminmod.cfg! FATAL ERROR");
		error=1;
	}
	if(!iFileAccessRead){
		selfmessage("[AdminMod Manager] file_access_read is not set to ^"1^" in adminmod.cfg! FATAL ERROR");
		error=1;
	}
	if(!iFileAccessWrite){
		selfmessage("[AdminMod Manager] file_access_write is not set to ^"1^" in adminmod.cfg! FATAL ERROR");
		error=1;
	}
	
	if(!error){
		plugin_registerinfo("AdminMod Manager","Change settings of AdminMod in game",STRING_VERSION);
		plugin_registercmd("admin_manager","admin_manager",ACCESS_RCON,"admin_manager: configurate your AdminMod in game");
		plugin_registercmd("say","HandleSay",ACCESS_ALL);
		plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
		plugin_registercmd("radio1","SetMenuData",ACCESS_ALL);
		plugin_registercmd("radio2","SetMenuData",ACCESS_ALL);
		plugin_registercmd("radio3","SetMenuData",ACCESS_ALL);
		plugin_registercmd("buyequip","SetMenuData",ACCESS_ALL);
		plugin_registercmd("buy","SetMenuData",ACCESS_ALL);
		plugin_registercmd("chooseteam","SetMenuData",ACCESS_ALL);
		plugin_registercmd("showbriefing","SetMenuData",ACCESS_ALL);
	}else{
		plugin_registerinfo("AdminMod Manager","DISABLED! Important settings are missing! See log files!",STRING_VERSION);
		selfmessage("[AdminMod Manager] Plugin disabled! Important settings are missing! See log files!");
	}
	return PLUGIN_CONTINUE;
}

public admin_manager(HLCommand,HLData,HLUserName,UserIndex){
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	if(!g_ClientLogin || g_ClientLogin==UserIndex){
		if(getvar("allow_client_exec")) {
			execclient(UserName,"toggleconsole");
		}
		g_ClientLogin=UserIndex;
		main_menu(UserName);
	}else{
		selfmessage("[AdminMod Manager] Sorry, someone else has control over plugin at the moment. Please try again later!");
	}
	return PLUGIN_HANDLED;
}

main_menu(User[]){
	new MainMenu[MAX_MENU_LENGTH];
	new keys=0;
	new key=1;
	new i;
	g_ClientMenu=MAIN_MENU;
	g_ClientKeyStart=1;
	g_ClientKeyEnd=ITEMS_PER_PAGE;
	strinit(g_ClientFile);
	snprintf(MainMenu,MAX_MENU_LENGTH,"[AdminMod Manager]^n");
	for(i=1;i<FILES;i++){
		keys |= key;
		snprintf(MainMenu,MAX_MENU_LENGTH,"%s^n%i. %s",MainMenu,i,g_File[i]);
		key <<= 1;
	}
	snprintf(MainMenu,MAX_MENU_LENGTH,"%s^n^n\r0. Cancel",MainMenu);
	keys+=512;
	menu(User,MainMenu,keys);
}	
		
read_file(User[],iLineStart,iLineEnd,iMode){
	new File[MAX_TEXT_LENGTH];
	new Menu[MAX_MENU_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iFileSize;
	new i;
	new keys=0;
	new key=1;
	new x;
	snprintf(File,MAX_TEXT_LENGTH,"%s%s",g_FileDir,g_ClientFile);
	
	if(!fileexists(File)){
		snprintf(Data,MAX_DATA_LENGTH,"[AdminMod Manager] ^n^n\r File ^"%s^" not found!^nFATAL ERROR",File);
		menu(User,Data,1023);
	}else{
		if(iMode){
			snprintf(Menu,MAX_MENU_LENGTH,"[%s]^n",g_ClientFile);
			iFileSize=filesize(File);
			if(iLineStart>iFileSize){
				iLineStart=1;
			}
			if(iLineEnd>iFileSize){
				iLineEnd=iFileSize;
			}
		}

		for(i=iLineStart;i<=iLineEnd;i++){
			if(iMode){
				x++;
			}
			readfile(File,Data,i,MAX_DATA_LENGTH);
			if(strlen(Data)!=0){
				keys |= key;
			}
			if(iMode){
				if(strlen(Data)!=0){
					if(strncmp(Data,"//",2)!=0 && strncmp(Data,"#",1)!=0 && strncmp(Data,";",1)!=0){
						snprintf(Menu,MAX_MENU_LENGTH,"%s^n\w%i.%s",Menu,x,Data);
					}else{
						snprintf(Menu,MAX_MENU_LENGTH,"%s^n\w%i.\r%s",Menu,x,Data);
					}
				}
				key <<= 1;
			}else{
				strcpy(g_ClientContent,Data,MAX_TEXT_LENGTH);
			}
		}

		if(iMode){
			snprintf(Menu,MAX_MENU_LENGTH,"%s^n",Menu);
			snprintf(Menu,MAX_MENU_LENGTH,"%s^n\y7. Add Line",Menu);
			keys+=64;
			if(iFileSize>iLineEnd){
				snprintf(Menu,MAX_MENU_LENGTH,"%s^n\y8. Next",Menu);
				keys+=128;
			}
			if(iLineStart>5){
				snprintf(Menu,MAX_MENU_LENGTH,"%s^n\y9. Back",Menu);
				keys+=256;
			}
			snprintf(Menu,MAX_MENU_LENGTH,"%s^n^n\r0. Cancel",Menu);
			keys+=512;
			menu(User,Menu,keys);
		}
	}
}

select_menu(User[]){
	new Menu[MAX_MENU_LENGTH];
	snprintf(Menu,MAX_MENU_LENGTH,"[%s]^n\y%s^n^n\w1. Edit Line^n2. De-/Activate Line^n^n\r0. Cancel",g_ClientFile,g_ClientContent);
	menu(User,Menu,515);
}

exec_menu(User[]){
	new Menu[MAX_MENU_LENGTH];
	snprintf(Menu,MAX_MENU_LENGTH,"[%s]^n\yOld: %s^n\rNew:\y%s^n^n\wUse 'chat' to edit line!^n^n1. Okay!^n^n\r0. Cancel",g_ClientFile,g_ClientContent,g_ClientNewContent);
	menu(User,Menu,513);
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,UserName,MAX_DATA_LENGTH);
	strstripquotes(Data);
	if(g_ClientMessageMode==UserIndex){
		strcpy(g_ClientNewContent,Data,MAX_DATA_LENGTH);
		exec_menu(UserName);
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}
	
public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	if(g_ClientLogin==UserIndex){
		new Data[MAX_DATA_LENGTH];
		new UserName[MAX_NAME_LENGTH];
		new iSelect;
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
		iSelect=strtonum(Data);
		//MAIN MENU
		if(g_ClientMenu==MAIN_MENU){
			if(iSelect==CANCEL){
				if(g_change){
					menu(UserName,"[AdminMod Manager]^n^n\rMapchange needed, that changings take effect!!",1024);
				}
				exit_plugin();
			}else{
				g_ClientMenu=LINE_MENU;
				strcpy(g_ClientFile,g_File[iSelect],MAX_TEXT_LENGTH);
				read_file(UserName,g_ClientKeyStart,g_ClientKeyEnd,1);
			}
		//READ FILE MENU
		}else if (g_ClientMenu==LINE_MENU){
			if(iSelect==CANCEL){
				main_menu(UserName);
			}else if(iSelect==BACK){
				g_ClientKeyStart=g_ClientKeyStart+ITEMS_PER_PAGE;
				g_ClientKeyEnd=g_ClientKeyEnd+ITEMS_PER_PAGE;
				read_file(UserName,g_ClientKeyStart,g_ClientKeyEnd,1);
			}else if(iSelect==NEXT){
				g_ClientKeyStart=g_ClientKeyStart-ITEMS_PER_PAGE;
				g_ClientKeyEnd=g_ClientKeyEnd-ITEMS_PER_PAGE;
				read_file(UserName,g_ClientKeyStart,g_ClientKeyEnd,1);
			}else if(iSelect==ADD){
				strinit(g_ClientContent);
				g_ClientSelect=-1;
				g_ClientMessageMode=UserIndex;
				g_ClientMenu=EXEC_MENU;
				exec_menu(UserName);
			}else{
				g_ClientSelect=g_ClientKeyStart+iSelect-1;
				read_file(UserName,g_ClientSelect,g_ClientSelect,0);
				g_ClientMenu=SELECT_MENU;
				select_menu(UserName);
			}
		//DATA SELECTED
		}else if (g_ClientMenu==SELECT_MENU){
			if(iSelect==CANCEL){
				g_ClientMenu=LINE_MENU;
				read_file(UserName,g_ClientKeyStart,g_ClientKeyEnd,1);
			}else if(iSelect==EDIT){
				g_ClientMenu=EXEC_MENU;
				g_ClientMessageMode=UserIndex;
				exec_menu(UserName);
			}else if(iSelect==COMMENT){
				if(strncmp(g_ClientContent,"//",2)!=0 && strncmp(g_ClientContent,"#",1)!=0 && strncmp(g_ClientContent,";",1)!=0 && strlen(g_ClientContent)!=0){
					snprintf(g_ClientContent,MAX_DATA_LENGTH,"#%s",g_ClientContent);
				}else{
					if(strncmp(g_ClientContent,"//",2)==0){
						strsubst(g_ClientContent, "//", "", MAX_DATA_LENGTH);
					}else if(strncmp(g_ClientContent,"#",1)==0){
						strsubst(g_ClientContent, "#", "", MAX_DATA_LENGTH);
					}else if(strncmp(g_ClientContent,";",1)==0){
						strsubst(g_ClientContent, ";", "", MAX_DATA_LENGTH);
					}
				}
				snprintf(Data,MAX_TEXT_LENGTH,"%s%s",g_FileDir,g_ClientFile);
				writefile(Data,g_ClientContent,g_ClientSelect);
				g_ClientMenu=LINE_MENU;
				g_change=1;
				read_file(UserName,g_ClientKeyStart,g_ClientKeyEnd,1);
			}
		//EXEC DATA MENU
		}else if (g_ClientMenu==EXEC_MENU){
			if(iSelect!=CANCEL){
				strcpy(g_ClientContent,g_ClientNewContent,MAX_TEXT_LENGTH);
				snprintf(Data,MAX_TEXT_LENGTH,"%s%s",g_FileDir,g_ClientFile);
				writefile(Data,g_ClientContent,g_ClientSelect);
			}
			g_ClientMenu=LINE_MENU;
			g_ClientMessageMode=0;
			strinit(g_ClientNewContent);
			read_file(UserName,g_ClientKeyStart,g_ClientKeyEnd,1);
		}
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;	
}

//RESET MENU ON DISCONNECT OR BY ANOTHER MENU		
public plugin_disconnect(HLUserName,UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		if(g_ClientLogin==UserIndex){
			exit_plugin();
		}
	}
	return PLUGIN_CONTINUE;
}

public SetMenuData(HLCommand,HLData,HLUserName,UserIndex){
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	if(g_ClientLogin==UserIndex){
		snprintf(Text,MAX_TEXT_LENGTH,"[AdminMod Manager] Menu is closed by another menu!");
		messageex(UserName,Text,print_chat);
		exit_plugin();
	}
	return PLUGIN_CONTINUE;
}

exit_plugin(){
	g_ClientLogin=0;
	g_ClientKeyStart=0;
	g_ClientKeyEnd=0;
	g_change=0;
	strinit(g_ClientFile);
	strinit(g_ClientContent);
	g_ClientMenu=0;
	g_ClientSelect=0;
	strinit(g_ClientNewContent);
	g_ClientMessageMode=0;
}